/*-
 * Copyright (C)2003..2025 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ident "@(#) Copyright (C)2003..2025 @BABOLO http://www.babolo.ru/\n"
#ident "@(#) $Id: writ.c,v 1.20 2025/01/29 05:33:42 babolo Exp $\n"

#define BLIN_COMPAT   4
#define MIFE_COMPAT   VMAJOR
#define MIFE_INTERNAL 1

#ifdef BLIN_OSLinux
# include <limits.h>
#else
# include <sys/limits.h>
#endif

#include <sys/types.h>
#include <sys/event.h>
#include <sys/time.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <babolo/BLINflag.h>
#include "mife.h"

ssize_t
mife_writ(int fd, const void *buf, size_t nbytes) {
    ssize_t e ;
    ssize_t s = 0;
    u_int   i ;

    if  (nbytes > SSIZE_MAX) {
        errno = EDOM;
        s = -1;
    } else if (!buf) {
        errno = EFAULT;
        s = -1;
    } else if (nbytes ? nbytes : (nbytes = strlen((const char *)buf))){
        for (i = 0; s < (ssize_t)nbytes;) {
            s += (e = write(fd, buf, nbytes));
            if  (e > 0) {
                i = 0;
            } else if ( e < 0) {
                s = e;
                break;
            } else if (i++ > NRETRY00) {
                errno = EPROTO;
                s = -(int)i;
            } else {
                usleep(1 << i);
    }   }   }
    return(s);
}
